<?php

namespace App\Http\Controllers;
use Illuminate\Support\Facades\Auth;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use App\Http\Controllers\SudaniSubscription;
use App\User;
use App\Exceptions\FEException;
use App\Helpers\FileManager;
use App\Http\Resources\UserResource;
use App\Helpers\Functions;
use Hash;
use App\Setting;
use Exception;

use Illuminate\Support\Facades\Cache;

class SudaniSubscriptionController extends Controller
{





   public static  function indexSudani(){
   return"ok";
    $sudaniSubscription = new SudaniSubscription();
    $result = $sudaniSubscription->checkSubscription("249110012403");
    
        return $result;
}


   public function loginSubscriber(Request $request){
    
      $request->validate([
         'phone' => ['required', 'string', 'regex:/^(0\d{9}|249\d{9})$/'],
     ], [
         'regex' => 'The phone number format is invalid.',
         'string' => 'The Phone number is not valid.',
         'required' => 'Please enter the phone number.'
     ]);

     //return $request->phone;
     $phone249 = Functions::getPhone249($request->phone);

       $sudaniSubscription = new SudaniSubscription();
      //return " ok";
      $result = $sudaniSubscription->checkSubscription($phone249);

       //update Dashboard
       //$sudaniSubscription->Dashboard($phone249,$result['status']);
    if($result['status']){
      $user = User::where('mobile', $phone249)->first();
      if($user == null){
        $user = User::create([
            'name' => $phone249,
            'mobile' => $phone249,
            'email' => $phone249.'@nxtlevel.com',
            'is_admin' => 1,
            'status' => 1,
            'password' => bcrypt($phone249),
            'verifyToken' => Str::random(40),
        ]);

        //return $user;

      $user->assignRole('TZARole');
     

      }
      
      if($user->status == false){
         $user->status = true;
         $user->save();
       }
       Auth::login($user);
      return redirect('/');

      }else{
        return back()->with('error', ' لست مشترك الرجاء التأكد من رقم الهاتف او الاشتراك');
      }
   }

   public function Unsubscribe(Request $request){
      $request->validate([
         'phone' => ['required', 'string', 'regex:/^(0\d{9}|249\d{9})$/'],
     ], [
         'regex' => 'The phone number format is invalid.',
         'string' => 'The Phone number is not valid.',
         'required' => 'Please enter the phone number.'
     ]);

     //return $request->phone;
     $phone249 = Functions::getPhone249($request->phone);
     $sudaniSubscription = new SudaniSubscription();
     $result = $sudaniSubscription->unsubscribe($phone249);
     Auth::logout();
     return redirect('/');
   }
     

   public function UpdateUser($phone){
      
      if(strlen($phone)== 8){
         $phone = '2491'.$phone;
      }
      $phone249 = Functions::getPhone249($phone);

      $sudaniSubscription = new SudaniSubscription();
      $result = $sudaniSubscription->checkSubscription($phone249);
      if($result['status']){
         $user = User::where('mobile', $phone249)->first();
         if($user == null){
           $user = User::create([
               'name' => $phone249,
               'mobile' => $phone249,
               'email' => $phone249.'@nxtlevel.com',
               'is_admin' => 1,
               'status' => 1,
               'password' => bcrypt($phone249),
               'verifyToken' => Str::random(40),
           ]);
   
           //return $user;
   
         $user->assignRole('TZARole');
        
   
         }
         
         if($user->status == false){
            $user->status = true;
            $user->save();
          }
          Auth::login($user);
   }
   }
    

  
 
}



